# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from edgeimpulse_api.models.get_inference_history_response_all_of_all_devices import GetInferenceHistoryResponseAllOfAllDevices
from edgeimpulse_api.models.get_inference_history_response_all_of_summary_by_time import GetInferenceHistoryResponseAllOfSummaryByTime
from edgeimpulse_api.models.inference_history_aggregate import InferenceHistoryAggregate

class GetInferenceHistoryResponse(BaseModel):
    success: StrictBool = Field(..., description="Whether the operation succeeded")
    error: Optional[StrictStr] = Field(None, description="Optional error description (set if 'success' was false)")
    summary_by_time: List[GetInferenceHistoryResponseAllOfSummaryByTime] = Field(..., alias="summaryByTime")
    summary_by_device: List[InferenceHistoryAggregate] = Field(..., alias="summaryByDevice")
    all_classes: List[StrictStr] = Field(..., alias="allClasses")
    all_devices: List[GetInferenceHistoryResponseAllOfAllDevices] = Field(..., alias="allDevices")
    all_metrics: List[StrictStr] = Field(..., alias="allMetrics")
    __properties = ["success", "error", "summaryByTime", "summaryByDevice", "allClasses", "allDevices", "allMetrics"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> GetInferenceHistoryResponse:
        """Create an instance of GetInferenceHistoryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in summary_by_time (list)
        _items = []
        if self.summary_by_time:
            for _item in self.summary_by_time:
                if _item:
                    _items.append(_item.to_dict())
            _dict['summaryByTime'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in summary_by_device (list)
        _items = []
        if self.summary_by_device:
            for _item in self.summary_by_device:
                if _item:
                    _items.append(_item.to_dict())
            _dict['summaryByDevice'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in all_devices (list)
        _items = []
        if self.all_devices:
            for _item in self.all_devices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['allDevices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetInferenceHistoryResponse:
        """Create an instance of GetInferenceHistoryResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return GetInferenceHistoryResponse.construct(**obj)

        _obj = GetInferenceHistoryResponse.construct(**{
            "success": obj.get("success"),
            "error": obj.get("error"),
            "summary_by_time": [GetInferenceHistoryResponseAllOfSummaryByTime.from_dict(_item) for _item in obj.get("summaryByTime")] if obj.get("summaryByTime") is not None else None,
            "summary_by_device": [InferenceHistoryAggregate.from_dict(_item) for _item in obj.get("summaryByDevice")] if obj.get("summaryByDevice") is not None else None,
            "all_classes": obj.get("allClasses"),
            "all_devices": [GetInferenceHistoryResponseAllOfAllDevices.from_dict(_item) for _item in obj.get("allDevices")] if obj.get("allDevices") is not None else None,
            "all_metrics": obj.get("allMetrics")
        })
        return _obj

